<%@page import="org.tinyradius.dictionary.DictionaryParser"%>
<%@page import="org.tinyradius.dictionary.Dictionary"%>
<%@page import="java.net.URLEncoder"%>

<%@ page info="OMG Captive Portal" %>
<%@ page import="com.inmotiontechnology.portal.*" %>
<%@ page import="org.tinyradius.packet.*" %>
<%@ page import="org.tinyradius.util.*" %>
<%@ page import="org.tinyradius.attribute.*" %>
<%@ page import="java.util.List" %>
<%@ page import="org.apache.log4j.Level" %>
<%@ page import="org.apache.log4j.Logger"%>

<META HTTP-EQUIV="expires" CONTENT="Wed, 26 Feb 1997 08:21:57 GMT">
<%
    Logger logger = Logger.getLogger(WebPortal.class);
try {
    response.setHeader("Connection","close");
    response.setHeader("Pragma", "No-Cache");
    response.setHeader("Cache-Control", "No-Store");
    response.setDateHeader("Expires", 0);
    response.setStatus(response.SC_OK);

    WebPortal wp = (WebPortal) session.getAttribute("servlet");
    String url = request.getParameter("url");
    if (wp != null) {
        String mode = wp.getConfigString(null,"mode");
        String ip = request.getRemoteAddr();
        String clientmac = wp.getMACAddress(request.getRemoteAddr()); //radius format
        String eui = clientmac;
        int defaultsessiontimeoutSec = wp.getConfigInt(null,"sessionTimeoutSec"); //convert seconds to ms

        if ( defaultsessiontimeoutSec <= 0 ) {
           defaultsessiontimeoutSec = 12*60*60; //default sesion timeout is 12 hours
        }
        if ( url == null ) {
            logger.info("Incoming request from: " + ip + " MAC: " + clientmac );
         }
        else {
            logger.info("Incoming request from: " + ip + " MAC: " + clientmac + " URL: " + url);
        }

        if (mode != null && mode.compareTo("uam") == 0 && clientmac != null && !clientmac.isEmpty() ) {
            clientmac.replaceAll(":","-"); //radius format
            int    WISPR_VENDOR_ID = wp.getConfigInt("wasOptions","wisprVendorId");
            String radiusip = OmgUtils.resolveHost(wp.getConfigString("radiusOptions","host"));
            String radiussec = wp.getConfigString("radiusOptions","secret");
            String wasserverurl = OmgUtils.resolveMacro(wp.getConfigString("wasOptions","host"));
            String wasipsubnet = wp.getConfigString("wasOptions","ipSubnet");
            String wisprlocationid = wp.getConfigString("wasOptions","wisprLocationId");
            String wisprlocationname = wp.getConfigString("wasOptions","wisprLocationName");

            if ( WISPR_VENDOR_ID == 0 || radiusip == null || radiussec == null ||
                 wasserverurl == null || wasipsubnet == null || wisprlocationid == null || wisprlocationname == null ){
                String configErr =
                                   "radiusOptions/host = " + radiusip + "\n" +
                                   "radius/secret = <cant show you>" + "\n" +
                                   "wasOptions/host = " + wasserverurl + "\n" +
                                   "wasOptions/ipSubnet = " + wasipsubnet + "\n" +
                                   "wasOptions/wisprVendorId = " + WISPR_VENDOR_ID + "\n" + 
                                   "wasOptions/wisprLocationId = " + wisprlocationid + "\n" +
                                   "wasOptions/wisprLocationName = " + wisprlocationname + "\n";
                logger.error("Malformed/incomplete yaml specification, webportal configuration error: " + configErr);
                mode = null;
                throw (new Exception("UAM Configuration error: " + configErr));
            }
            else {
                String nasinterface = "eth0"; 
                int nasporttype = wp.getConfigInt("radiusOptions","nasPortType");//wlan
                int nasportidx = wp.getConfigInt("radiusOptions","nasPortIndex"); //wlan0
        
                 //radius / willichilli based authentication
                 String redirecturl = null;
                 String msg = "";

                //different parameters from radius/willi
                String username = request.getParameter("username"); 
                String password = request.getParameter("password");
                String sid = request.getParameter("sid");
                String purl = request.getParameter("purl");
                String secret = request.getParameter("secret"); //TODO?

                //nas id is interface id
                String nasid = wp.getInterfaceMACAddress(nasinterface);

                if ( nasid == null ){
                   logger.error("Cannot retrieve MAC address of " + nasinterface + ", unable to redirect http requests to WAS.");
                   mode = null;
                }
                else { 
                  nasid.replaceAll(":","-"); 
                }

                //initial redirect to WAS to provide login
                //TODO should validate sid/purl instead since original request might have a username and password
                if (nasid != null && sid == null && (username == null || password == null)) {
                    //add was rules to firewall
                    wp.enableAccessTo(ip, wasipsubnet);

                    //wan address of the omg
                    String wanip = request.getLocalAddr();
                
                    if ( nasid != null ) {
                        nasid.replaceAll(":","-"); 
                        redirecturl = wasserverurl + 
                        "?wanip=" + wanip + ":" + request.getServerPort() +
                        "&nasip=" + wanip +
                        "&clientip=" + request.getRemoteAddr() +
                        "&clienturl=" + URLEncoder.encode(request.getRequestURL().toString()) +
                        "&clientlang=" + URLEncoder.encode(request.getLocale().getLanguage()) +
                        "&nasid=" + URLEncoder.encode(nasid) +
                        "&clientmac=" + URLEncoder.encode(clientmac) +
                        "&mac=" + URLEncoder.encode(clientmac);
                    }
                    else {
                        //error retrieving bridge mac address, default to basic mode
                        logger.warn("Unable to retrieve MAC address of bridge for client " + ip + ". Default to basic mode");
                        mode = null;
                    }
                }
                else if ( nasid != null) {
                    logger.info("Callback from WAS, verifing with radius server " + radiusip + " for user " + username); 
                    //callback from WAS, verify with radius 
                    //username, pasword or some sort of atuh token from AC
                    RadiusClient rc = new RadiusClient(radiusip, radiussec);


                    //callback from WAS, verify with radius 
                    AccessRequest ar = new MessageAuthAccessRequest(username, password);
                    ar.setAuthProtocol(AccessRequest.AUTH_CHAP); // or AUTH_PAP                
                    ar.addAttribute(new IpAttribute(4, request.getRemoteAddr())); //nas-ip-address
                    ar.addAttribute(new IntegerAttribute(6, 2)); //service-type = framed (hardcoded in willichilli redir.c:1477)
                    ar.addAttribute(new IpAttribute(8, request.getRemoteAddr())); //framed-ip-address
                    ar.addAttribute(new IpAttribute(12, 1400)); //MTU size = 1400 hardcoded in willichilli redir.c:1485 
                    ar.addAttribute(new IntegerAttribute(55, (int)(System.currentTimeMillis()/1000))); //timestamp in secs since epoch
                    ar.addAttribute(new StringAttribute(31, clientmac)); //calling station id==client mac redir.c:1496
                    ar.addAttribute(new StringAttribute(30, nasid)); //called station id=nas id
                    ar.addAttribute(new StringAttribute(32, nasid)); //nas-identifier
                    ar.addAttribute(new IntegerAttribute(61, nasporttype)); //nas-port-type=wifi redir.c:1516 (probably not needed)
                    ar.addAttribute(new IntegerAttribute(5, nasportidx)); //nas-port=2 redir.c:1521
                    ar.addAttribute(new StringAttribute(80, "")); //message-authenticator -- gets generated by the radius packet
                    VendorSpecificAttribute v1 = new VendorSpecificAttribute(WISPR_VENDOR_ID); //wispr
                    v1.addSubAttribute("WISPr-Location-Name", wisprlocationname);
                    ar.addAttribute(v1);
                    VendorSpecificAttribute v2 = new VendorSpecificAttribute(WISPR_VENDOR_ID); //wispr
                    v2.addSubAttribute("WISPr-Location-ID", wisprlocationid);
                    ar.addAttribute(v2);
                    RadiusPacket rp = null;
                    try {
                        logger.info("Starting Radius exchange with " + radiusip + " for user " + username + " on ip " + request.getRemoteAddr());
                        rp = rc.authenticate(ar);
                        logger.info("Completed Radius exchange with " + radiusip + " for user " + username + " on ip " + request.getRemoteAddr());
                    }
                    catch (Exception exp) {
                        OmgDels.sendAuthenticationServerUnavailable(exp.getMessage());
                        logger.fatal("Failed to communicate with Radius Server @ " + radiusip + ": " + exp);
%>
<html>
<body>
<h1>Radius Authentication Server Error.</h1>
Logging exception message to Web Portal logfile. Please contact customer support.<br>
<pre>
<%
    out.println(exp);
    String errMsg = "";
    for ( StackTraceElement element : exp.getStackTrace() ){
       errMsg += element.toString() + "\n";
    }
    if ( !errMsg.isEmpty() ) {
        logger.fatal(errMsg);
        out.println(errMsg);
    }
%>
</pre>
</body>
</html>
<%
                       response.setStatus(response.SC_SERVICE_UNAVAILABLE, "Authentication server unavailable");
                       rp = null;
                    }
                    if (rp != null && rp.getPacketType() == RadiusPacket.ACCESS_ACCEPT) {
                        String options = "";
                        logger.info("Authenticated user " + username + " from ip " + request.getRemoteAddr() ); 
                        //default redirect url
                        redirecturl = String.format("%s?e=%d&world=hello&sid=%s", wasserverurl, 0, sid);
                        
                        //timeout before rekey
                        long tmout = defaultsessiontimeoutSec;
                        RadiusAttribute timeoutattr = rp.getAttribute(27); //RADIUS_ATTR_SESSION_TIMEOUT
                        if (timeoutattr != null) {
                            tmout = ((IntegerAttribute)timeoutattr).getAttributeValueInt();
                            if ( tmout <= 0 ) {
                               tmout = defaultsessiontimeoutSec;
                            }
                            options += "sessionLimitSec=" + tmout;
                        }
                        //vendor specific attributes
                        int maxbandwidthdown = 0;
                        int maxbandwidthup = 0;
                        List vendattrs = rp.getVendorAttributes(WISPR_VENDOR_ID);
                        for (Object vendattr : vendattrs) {
                            if (vendattr instanceof VendorSpecificAttribute) {
                                VendorSpecificAttribute vendspec = (VendorSpecificAttribute) vendattr;
                                List subattrs = vendspec.getSubAttributes();
                                for (Object subattr: subattrs) {
                                    RadiusAttribute radattr = (RadiusAttribute) subattr;
                                    switch (radattr.getAttributeType()) {
                                    case 4: //redirection url
                                        redirecturl = ((StringAttribute) radattr).getAttributeValue();
                                        break;
                                    case 7: //max bandwidth up
                                        maxbandwidthup= ((IntegerAttribute) radattr).getAttributeValueInt();
                                        options += " maxUpload=" + maxbandwidthup;
                                        break;
                                    case 8: //max bandwidth down
                                        maxbandwidthdown = ((IntegerAttribute) radattr).getAttributeValueInt();
                                        options += " maxDownload=" + maxbandwidthdown;
                                        break;
                                    }
                                }
                            }
                        }
                        logger.info("Success in authentication with radius server: " + rp.getPacketTypeName() + " and " + rp.getAttributes());
                        logger.info("Enabled " + ip + " with timeout " + tmout + " secs");
                        wp.enableAccess(ip, tmout*1000); //tmout in ms
                        OmgDels.sendAuthenticationSuccess(username,options, eui);
                    }
                    else if (rp != null) {
                        //TODO convert to proper packet code, ala redir_reply() in redir.c
                        //tell sap that this did not work
                        wp.disableAccess(ip);
                        String failure = "Failed to authenticate with radius: " + rp.getPacketTypeName() + " and " + rp.getAttributes();
                        logger.warn(failure);
                        redirecturl = String.format("%s?e=%d&world=hello&sid=%s&extra=%d", wasserverurl, 112, sid, rp.getPacketType());
                        OmgDels.sendAuthenticationFailure(failure,eui);
                    }
                }
                //redirect if so
                if (redirecturl != null && nasid != null) {
                    logger.info("Redirecting " + request.getRemoteAddr() + " to " + redirecturl);
                    response.sendRedirect(redirecturl);
                    OmgDels.sendRedirect(ip,eui);
                }
            } 
        } // mode=uam

        if ( mode == null || mode.compareTo("basic")==0 ){
            //old style client captive portal; grant login for nothing more than a song
            if ( request.getParameter("accepted") != null) {
                logger.info(ip + " accepted terms. Granting web access, timeout " + defaultsessiontimeoutSec + "(s). Re-directing to " + url);
                wp.enableAccess(ip, defaultsessiontimeoutSec*1000); 
                Thread.sleep(2000);
                response.setHeader("Location", url);
                response.setStatus(302);
            }
            else if ( wp.isEnabled(ip) ) {
                logger.info(ip + " is enabled. Displaying welcome.htm page");
%>
<%@ include file="webportal/welcome.htm" %>
<%
             }
             else {    
                logger.info(ip + " does not have access. Displaying portal login.htm page.");
		// No need to clear connection. In fact doing so is harmful.
                // wp.disableAccess(ip);
%>
<%@ include file="webportal/login.htm" %>
<%
                OmgDels.sendRedirect(ip,eui);
                }
       } //mode=basic 
    } else {
          logger.fatal("Web Portal servlet not found in session! Unable to display webportal page.");
          response.setStatus(response.SC_SERVICE_UNAVAILABLE, "Web Portal servlet not found in session.");
    }
}
catch (Exception exp) {
    logger.fatal("Unhandled exception caught: " + exp);
    String errMsg = "";
    for ( StackTraceElement element : exp.getStackTrace() ){
       errMsg += element.toString() + "\n";
    }
    if ( !errMsg.isEmpty() ) {
        logger.fatal(errMsg);
    }
%>
<html>
<body>
<h1>Web Portal encountered an unhandled exception.</h1>
Logging exception message to Web Portal logfile. Service temporarily unavailable, please try later.
<pre>
<%
   out.println(exp);
   out.println(errMsg);
%>
</pre>
</body>
</html>
<%
}
%>
